//+------------------------------------------------------------------+
//|                                                     channel.mq4  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Coral
//----
extern int x_prd = 12;
extern int CountBars = 300;//   
//---- buffers
double dpo[];
double tob[];
double tos[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0, DRAW_LINE);//     dpo
   SetIndexStyle(1, DRAW_LINE);//     dpo
   SetIndexBuffer(0, tob);//     dpo
   SetIndexBuffer(1, tos);//     dpo
//---- name for DataWindow and indicator subwindow label
   short_name = "Channel(" + x_prd + ")";//  
   IndicatorShortName(short_name);//    
   SetIndexLabel(0, short_name);//   
//----
   if(CountBars >= Bars)//            ...
   CountBars = Bars;//...     
   SetIndexDrawBegin(0, Bars - CountBars/* + x_prd*/ + 1);//      ,     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| DPO                                                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, counted_bars=IndicatorCounted();//  ,      .
   double t_prd;//  t_prd
//----
   if(Bars <= x_prd)//       ,    
       return(0);
//---- initial zero
   if(counted_bars < x_prd)
     {
       for(i = 1; i <= x_prd; i++) 
           dpo[CountBars-i] = 0.0;
     }
//----
   i = CountBars /*- x_prd*/ - 1;
   t_prd = x_prd / 2 + 1;
//----
   while(i >= 0)
     {
       dpo[i] = Close[i] - iMA(NULL, 0, t_prd, 0, MODE_SMA, PRICE_CLOSE, i);
       i--;
     }
   i = CountBars /*- x_prd*/ - 1;
   ArrayResize(tob,CountBars);
   ArrayResize(tos,CountBars);
   while(i >= 0)
     {
       ArrayFill(tob,i,1,maxp(i));//tob[i] = maxp(i);
       ArrayFill(tos,i,1,minp(i));//tos[i] = minp(i);
       Print (i,"/",tob[i],"/",tos[i]);
       i--;
     }  
   Print("   (0) = "+maxp(0));
   Print("   (0) = "+minp(0));
   Print("tob[0] = "+tob[0]);
   Print("tos[0] = "+tos[0]);
 return(0);
  }
//+------------------------------------------------------------------+-------------+
//+------------------------------------------------------------------+
//| Calculate Max price                                   |
//+------------------------------------------------------------------+
double maxp(int nbar)
  {
   int k;
   double t_prd = x_prd / 2 + 1;
   double gdpomax;// 
   double ldpomax;// 
   for(k = nbar; k <= CountBars-nbar; k++){
           //gdpomin = MathMin(gdpomin,dpo[k]);
           gdpomax = MathMax(gdpomax,dpo[k-1]);
           //Print (k," = ",dpo[k]," / " ,gdpomax);
           }
   //double urgdpomin = 0.7*gdpomin;
   double urgdpomax = 0.7*gdpomax;
   //     +70%
   for(k = nbar; dpo[k] < urgdpomax; k++){//         c +70 (    +70%)
       int firstmaxbar = k+1;
       //Print (k," = ",dpo[k]," > ",urgdpomax);
       }
   //     +70%
   for(k = firstmaxbar; dpo[k] > urgdpomax; k++){//          c +70
       //Print (" = "+firstmaxbar);
       int lastmaxbar = k;
       //Print (k," = ",dpo[k]," > ",urgdpomax);
       }
   //  
   if(firstmaxbar != lastmaxbar){
   for(k = firstmaxbar; k < lastmaxbar; k++){//   
      ldpomax = MathMax(ldpomax,dpo[k]);
      }
    }else{
    ldpomax = dpo[firstmaxbar];
    }
   //   
   double a;
   int j;
   for(j = 1+nbar; j <= nbar+t_prd-1; j++){//  
       a = a+Close[j];
       //Print(j+"/"+Close[j]+"/"+a);
       }
   //double dpo0 = Close[0] - (Close[0]+a)/t_prd;//
   double max_tp = (t_prd*ldpomax+a)/(t_prd - 1);
//--- return calculated value
   return(max_tp);//  
  }
//+------------------------------------------------------------------+

double minp(int nbar)
  {
   int k;
   double t_prd = x_prd / 2 + 1;
   //  
   double gdpomin;// 
   double ldpomin;// 
   for(k = nbar; k <= CountBars-nbar; k++){
           gdpomin = MathMin(gdpomin,dpo[k]);
           }
   double urgdpomin = 0.7*gdpomin;
   //     -70%
   for(k = nbar; dpo[k] > urgdpomin; k++)//         c -70 (    -70%)
       //Print (k," = ",dpo[k]," > ",urgdpomin);
       int firstminbar = k+1;
   //     -70%   
   for(k = firstminbar; dpo[k] < urgdpomin; k++)//         c -70
       int lastminbar = k;
   //  
   if(firstminbar != lastminbar){
   for(k = firstminbar; k < lastminbar; k++){//   
      ldpomin = MathMin(ldpomin,dpo[k]);
      }
   }else{
   ldpomin =dpo[firstminbar];
   }
   //  
   double a;
   int j;
   for(j = 1+nbar; j <= nbar+t_prd-1; j++){//  
       a = a+Close[j];
       //Print(j+"/"+Close[j]+"/"+a);
       }
   //double dpo0 = Close[0] - (Close[0]+a)/t_prd;//
   double min_tp = (t_prd*ldpomin+a)/(t_prd - 1);
//--- return calculated value
   return(min_tp);//  
  }
//+------------------------------------------------------------------+